#!/usr/bin/env bash

set -eu

# Initialization tasks
echo "Running initialization script..."

# Save all autosubmit related variables to an array
mapfile -t autosubmit_env_var < <(env | grep 'AUTOSUBMIT_')

# Check git repo and branch are difined
if [[ ! (-z "$AUTOSUBMIT_GIT_REPO" || -z "$AUTOSUBMIT_GIT_BRANCH") ]] 
then
   # Create autosubmit expid
   autosubmit expid    --description "EDITO AUTOMATED RUN"   \
                       --minimal_configuration               \
                       --git_repo ${AUTOSUBMIT_GIT_REPO}     \
                       --git_branch ${AUTOSUBMIT_GIT_BRANCH} \
                       --git_as_conf "autosubmit_conf/" > expid.txt
else
 echo "ERROR, either AUTOSUBMIT_GIT_REPO or  AUTOSUBMIT_GIT_BRANCH undefined"
 exit 1
fi

# Retrieve autosubmit expid
expid=`tail -1 expid.txt | awk '{print $2}'`

# Create autosubmit experiment expid so it downloads the git repo
autosubmit create -np ${expid}