#!/usr/bin/env bash

set -eu

./load_ssh_private_key.sh

# Initialization tasks
echo "Running entrypoint script..."

# Save all autosubmit related variables to an array
mapfile -t autosubmit_env_var < <(env | grep 'AUTOSUBMIT_')

# Retrieve autosubmit expid
expid=`tail -1 expid.txt | awk '{print $2}'`

# Substitute all autosubmit related env variables in cloned repo files
cd /app/autosubmit/experiments/${expid}/proj/git_project
for i_env in "${autosubmit_env_var[@]}"
do
    key=${i_env%=*}
    value=${i_env##*=}
    find . -type f | xargs sed -i "s#${key}#${value}#g" 
    
done

# Execute the main command
echo "Initialization complete. Running main command..."
exec "$@"